diff -crN nakedmudv1.5/src/time/mudtime.h nakedmudv2.0/src/time/mudtime.h
*** nakedmudv1.5/src/time/mudtime.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/time/mudtime.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 4,10 ****
  //
  // mudtime.h
  //
! // We can't use time.c, because it is a standard C header. A small module for
  // handling time of day in the MUD.
  //
  //*****************************************************************************
--- 4,10 ----
  //
  // mudtime.h
  //
! // We can't use time.h, because it is a standard C header. A small module for
  // handling time of day in the MUD.
  //
  //*****************************************************************************
***************
*** 15,20 ****
--- 15,25 ----
  // #define MODULE_TIME
  //
  
+ #define MUD_HOUR       * 5 MINUTES
+ #define MUD_HOURS      * 5 MINUTES
+ 
+ 
+ 
  //
  // Set up the time module
  //
***************
*** 55,73 ****
  
  
  //
- // Tell the character information about the time
- // 
- COMMAND(cmd_time);
- 
- 
- //
  // If we have the time module installed, there is the option of
  // supplying a night description for the room, that will be shifted
  // to when it becomes evening/night time.
  //
! const char *roomGetNightDesc   (ROOM_DATA *room);
! char      **roomGetNightDescPtr(ROOM_DATA *room);
! void        roomSetNightDesc   (ROOM_DATA *room, const char *desc);
  
  
  #endif // __MUDTIME_H
--- 60,72 ----
  
  
  //
  // If we have the time module installed, there is the option of
  // supplying a night description for the room, that will be shifted
  // to when it becomes evening/night time.
  //
! const char *roomGetNightDesc      (ROOM_DATA *room);
! BUFFER     *roomGetNightDescBuffer(ROOM_DATA *room);
! void        roomSetNightDesc      (ROOM_DATA *room, const char *desc);
  
  
  #endif // __MUDTIME_H
diff -crN nakedmudv1.5/src/time/time.c nakedmudv2.0/src/time/time.c
*** nakedmudv1.5/src/time/time.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/time/time.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,30 ****
  
  
  #define TIME_FILE   "../lib/misc/time"  // where do we keep time data?
! #define TIME_UPDATE_DELAY    5 MINUTES  // how long is an in-game hour?
  #define HOURS_PER_DAY               24  // how many hours are in a day?
  #define NUM_MONTHS                   4  // how many months are in a year?
  #define DAYS_PER_WEEK                3  // how many days are in a week?
  #define USE_AMPM                  TRUE  // do we use the am/pm system?
  
  
  struct month_data {
    char *name;             // what is the name of the month?
--- 19,32 ----
  
  
  #define TIME_FILE   "../lib/misc/time"  // where do we keep time data?
! #define TIME_UPDATE_DELAY   1 MUD_HOUR  // how long is an in-game hour?
  #define HOURS_PER_DAY               24  // how many hours are in a day?
  #define NUM_MONTHS                   4  // how many months are in a year?
  #define DAYS_PER_WEEK                3  // how many days are in a week?
  #define USE_AMPM                  TRUE  // do we use the am/pm system?
  
+ COMMAND(cmd_time);                      // a player command for seeing the time
+ 
  
  struct month_data {
    char *name;             // what is the name of the month?
***************
*** 71,96 ****
  //
  //*****************************************************************************
  typedef struct time_aux_data {
!   char *night_desc;        // our description at night time
  } TIME_AUX_DATA;
  
  TIME_AUX_DATA *
  newTimeAuxData() {
    TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
!   data->night_desc = strdup("");
    return data;
  }
  
  void
  deleteTimeAuxData(TIME_AUX_DATA *data) {
!   if(data->night_desc) free(data->night_desc);
    free(data);
  }
  
  void
  timeAuxDataCopyTo(TIME_AUX_DATA *from, TIME_AUX_DATA *to) {
!   if(to->night_desc) free(to->night_desc);
!   to->night_desc = strdup(from->night_desc ? from->night_desc : "");
  }
  
  TIME_AUX_DATA *
--- 73,97 ----
  //
  //*****************************************************************************
  typedef struct time_aux_data {
!   BUFFER *night_desc;        // our description at night time
  } TIME_AUX_DATA;
  
  TIME_AUX_DATA *
  newTimeAuxData() {
    TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
!   data->night_desc = newBuffer(1);
    return data;
  }
  
  void
  deleteTimeAuxData(TIME_AUX_DATA *data) {
!   if(data->night_desc) deleteBuffer(data->night_desc);
    free(data);
  }
  
  void
  timeAuxDataCopyTo(TIME_AUX_DATA *from, TIME_AUX_DATA *to) {
!   bufferCopyTo(from->night_desc, to->night_desc);
  }
  
  TIME_AUX_DATA *
***************
*** 102,135 ****
  
  STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "night_desc", data->night_desc);
    return set;
  }
  
  TIME_AUX_DATA *timeAuxDataRead(STORAGE_SET *set) {
!   TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
!   data->night_desc = strdup(read_string(set, "night_desc"));
    return data;
  }
  
  const char *roomGetNightDesc(ROOM_DATA *room) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   return data->night_desc;
  }
  
! char **roomGetNightDescPtr(ROOM_DATA *room) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   return &(data->night_desc);
  }
  
  void roomSetNightDesc(ROOM_DATA *room, const char *desc) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   if(data->night_desc) free(data->night_desc);
!   data->night_desc = strdup(desc ? desc : "");
  }
  
  
- 
  //*****************************************************************************
  //
  // time handling functions
--- 103,135 ----
  
  STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "night_desc", bufferString(data->night_desc));
    return set;
  }
  
  TIME_AUX_DATA *timeAuxDataRead(STORAGE_SET *set) {
!   TIME_AUX_DATA *data = newTimeAuxData();
!   bufferCat(data->night_desc, read_string(set, "night_desc"));
    return data;
  }
  
  const char *roomGetNightDesc(ROOM_DATA *room) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   return bufferString(data->night_desc);
  }
  
! BUFFER *roomGetNightDescBuffer(ROOM_DATA *room) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   return data->night_desc;
  }
  
  void roomSetNightDesc(ROOM_DATA *room, const char *desc) {
    TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
!   bufferClear(data->night_desc);
!   bufferCat(data->night_desc, (desc ? desc : ""));
  }
  
  
  //*****************************************************************************
  //
  // time handling functions
diff -crN nakedmudv1.5/src/time/time.d nakedmudv2.0/src/time/time.d
*** nakedmudv1.5/src/time/time.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/time/time.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ time/time.d time/time.o: time/time.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h inform.h character.h \
+   room.h event.h storage.h auxiliary.h time/mudtime.h
diff -crN nakedmudv1.5/src/utils.c nakedmudv2.0/src/utils.c
*** nakedmudv1.5/src/utils.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/utils.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 27,36 ****
  #include "action.h"
  
  
! // optional modules
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  /*
--- 27,38 ----
  #include "action.h"
  
  
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! 
  
  
  /*
***************
*** 51,59 ****
    return TRUE;
  }
  
  void extract_obj(OBJ_DATA *obj) {
!   // make sure there's no events going that involve us
!   interrupt_events_involving(obj);
  
    // make sure we're not attached to anything
    CHAR_DATA *sitter = NULL;
--- 53,74 ----
    return TRUE;
  }
  
+ 
+ void  add_extract_obj_func (void (* func)(OBJ_DATA *)) {
+   listQueue(extract_obj_funcs, func);
+ }
+ 
+ void  add_extract_mob_func (void (* func)(CHAR_DATA *)) {
+   listQueue(extract_mob_funcs, func);
+ }
+ 
  void extract_obj(OBJ_DATA *obj) {
!   // go through all of our extraction functions
!   LIST_ITERATOR *ex_i = newListIterator(extract_obj_funcs);
!   void (* ex_func)(OBJ_DATA *) = NULL;
!   ITERATE_LIST(ex_func, ex_i)
!     ex_func(obj);
!   deleteListIterator(ex_i);
  
    // make sure we're not attached to anything
    CHAR_DATA *sitter = NULL;
***************
*** 81,94 ****
  
  
  void extract_mobile(CHAR_DATA *ch) {
!   // interrupt actions and events associated with us
! #ifdef MODULE_FACULTY
!   interrupt_action(ch, FACULTY_ALL);
!   clear_faculties(ch);
! #else
!   interrupt_action(ch, 1);
! #endif
!   interrupt_events_involving(ch);
  
    // unequip everything the character is wearing
    // and send it to inventory
--- 96,107 ----
  
  
  void extract_mobile(CHAR_DATA *ch) {
!   // go through all of our extraction functions
!   LIST_ITERATOR *ex_i = newListIterator(extract_mob_funcs);
!   void (* ex_func)(CHAR_DATA *) = NULL;
!   ITERATE_LIST(ex_func, ex_i)
!     ex_func(ch);
!   deleteListIterator(ex_i);
  
    // unequip everything the character is wearing
    // and send it to inventory
***************
*** 129,137 ****
      send_to_char(dMob, "{yYou say, '%s'{n\r\n", txt);
      message(dMob, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR, other_buf);
      try_dialog_all(dMob, roomGetCharacters(charGetRoom(dMob)), txt);
- #ifdef MODULE_SCRIPTS
      try_speech_script(dMob, NULL, txt);
- #endif
      break;
    }
  
--- 142,148 ----
***************
*** 153,159 ****
  /*
   * load the world and its inhabitants, as well as other misc game data
   */
! void load_muddata(bool fCopyOver) {  
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
      log_string("ERROR: Could not boot game world.");
--- 164,170 ----
  /*
   * load the world and its inhabitants, as well as other misc game data
   */
! void load_muddata() {  
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
      log_string("ERROR: Could not boot game world.");
***************
*** 162,171 ****
  
    greeting = read_file("../lib/txt/greeting");
    motd     = read_file("../lib/txt/motd");
- 
-   /* copyover */
-   if (fCopyOver)
-     copyover_recover();
  }
  
  
--- 173,178 ----
***************
*** 220,295 ****
    }
  }
  
- 
- /* Recover from a copyover - load players */
- void copyover_recover()
- {     
-   CHAR_DATA *dMob;
-   SOCKET_DATA *dsock;
-   FILE *fp;
-   char name [100];
-   char host[MAX_BUFFER];
-   int desc;
-       
-   log_string("Copyover recovery initiated");
-    
-   if ((fp = fopen(COPYOVER_FILE, "r")) == NULL)
-   {  
-     log_string("Copyover file not found. Exitting.");
-     exit (1);
-   }
-       
-   /* In case something crashes - doesn't prevent reading */
-   unlink(COPYOVER_FILE);
-     
-   for (;;)
-   {  
-     fscanf(fp, "%d %s %s\n", &desc, name, host);
-     if (desc == -1)
-       break;
- 
-     dsock = malloc(sizeof(*dsock));
-     clear_socket(dsock, desc);
-   
-     dsock->hostname     =  strdup(host);
-     listPut(socket_list, dsock);
-  
-     /* load player data */
-     if ((dMob = load_player(name)) != NULL)
-     {
-       /* attach to socket */
-       charSetSocket(dMob, dsock);
-       dsock->player    =  dMob;
- 
-       // try putting the character into the game
-       // close the socket if we fail.
-       try_enter_game(dMob);
-     }
-     else /* ah bugger */
-     {
-       close_socket(dsock, FALSE);
-       continue;
-     }
-    
-     /* Write something, and check if it goes error-free */
-     if (!text_to_socket(dsock, "\n\r <*>  And before you know it, everything has changed  <*>\n\r"))
-     { 
-       close_socket(dsock, FALSE);
-       continue;
-     }
-   
-     /* make sure the socket can be used */
-     dsock->bust_prompt    =  TRUE;
-     dsock->lookup_status  =  TSTATE_DONE;
-     dsock->state          =  STATE_PLAYING;
- 
-     /* negotiate compression */
-     text_to_buffer(dsock, (char *) compress_will2);
-     text_to_buffer(dsock, (char *) compress_will);
-   }
-   fclose(fp);
- }     
- 
  CHAR_DATA *check_reconnect(const char *player)
  {
    CHAR_DATA *dMob;
--- 227,232 ----
***************
*** 677,682 ****
--- 614,655 ----
  }
  
  //
+ // counts how many times word occurs in string. Assumes strlen(word) >= 1
+ //
+ int count_occurences(const char *string, const char *word) {
+   int count = 0, i = 0, word_len = strlen(word);
+   for(; string[i] != '\0'; i++) {
+     if(!strncmp(string, word, word_len)) {
+       count++;
+       i += word_len - 1;
+     }
+   }
+   return count;
+ }
+ 
+ //
+ // return a pointer to the start of the line num (lines are ended with \n's).
+ // return NULL if the line does not exist
+ //
+ char *line_start(char *string, int line) {
+   // skip forward to the appropriate line
+   int i, count = 1;
+ 
+   // are we looking for the start?
+   if(line == 1) return string;
+ 
+   for(i = 0; string[i] != '\0'; i++) {
+     if(string[i] == '\n')
+       count++;
+     if(count == line)
+       return string+i+1;
+   }
+ 
+   return NULL;
+ }
+ 
+ 
+ //
  // trim trailing and leading whitespace
  //
  void trim(char *string) {
***************
*** 1301,1308 ****
  }
  
  
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
!   sprintf(prompt, "\r\nprompt> ");
    return prompt;
  }
--- 1274,1286 ----
  }
  
  
+ void show_prompt(SOCKET_DATA *socket) {
+   text_to_buffer(socket, custom_prompt(socketGetChar(socket)));
+ }
+ 
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
!   *prompt = '\0';
!   strcat(prompt, "\r\nprompt> ");    
    return prompt;
  }
diff -crN nakedmudv1.5/src/utils.d nakedmudv2.0/src/utils.d
*** nakedmudv1.5/src/utils.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/utils.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ utils.d utils.o: utils.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h character.h object.h world.h \
+   zone.h room.h exit.h socket.h utils.h save.h handler.h inform.h \
+   dialog.h event.h action.h scripts/script.h
diff -crN nakedmudv1.5/src/utils.h nakedmudv2.0/src/utils.h
*** nakedmudv1.5/src/utils.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/utils.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 9,16 ****
  //*****************************************************************************
  
  
- #include "text_editor.h"
- 
  
  //*****************************************************************************
  //
--- 9,14 ----
***************
*** 59,64 ****
--- 57,63 ----
  bool  try_dialog          (CHAR_DATA *ch, CHAR_DATA *listener,const char *mssg);
  void  try_dialog_all      (CHAR_DATA *ch, LIST *listeners, const char *mssg);
  
+ void     show_prompt(SOCKET_DATA *socket);
  const char *custom_prompt (CHAR_DATA *ch);
  
  //*****************************************************************************
***************
*** 101,111 ****
  void format_string        (char **ptr_string, int max_width, 
  		          unsigned int maxlen, bool indent);
  int  count_letters        (const char *string, const char ch, const int strlen);
  int  fgetline             (FILE *file, char *p, int maxlen);
  void center_string        (char *buf, const char *string, int linelen, 
  			   int buflen, bool border);
! 
! 
  
  
  //*****************************************************************************
--- 100,112 ----
  void format_string        (char **ptr_string, int max_width, 
  		          unsigned int maxlen, bool indent);
  int  count_letters        (const char *string, const char ch, const int strlen);
+ int  count_occurences     (const char *string, const char *word);
+ char *line_start          (char *string, int line);
  int  fgetline             (FILE *file, char *p, int maxlen);
  void center_string        (char *buf, const char *string, int linelen, 
  			   int buflen, bool border);
! int next_space_in         (char *string);
! int next_letter_in        (const char *string, char marker);
  
  
  //*****************************************************************************
***************
*** 113,125 ****
  // utilities for game functioning
  //
  //*****************************************************************************
- char *get_time             ( void );
  void  extract_obj          ( OBJ_DATA *obj);
  void  extract_mobile       ( CHAR_DATA *ch );
  bool  check_name           ( const char *name );
  void  communicate          ( CHAR_DATA *dMob, char *txt, int range );
! void  load_muddata         ( bool fCopyOver );
! void  copyover_recover     ( void );
  CHAR_DATA  *check_reconnect( const char *player );
  
  // iterate across all the elements in a list
--- 114,130 ----
  // utilities for game functioning
  //
  //*****************************************************************************
  void  extract_obj          ( OBJ_DATA *obj);
  void  extract_mobile       ( CHAR_DATA *ch );
+ 
+ // Make sure a certain procedure is called when we are extracting an npc/char
+ void  add_extract_obj_func ( void (* func)(OBJ_DATA *));
+ void  add_extract_mob_func ( void (* func)(CHAR_DATA *));
+ 
+ char *get_time             ( void );
  bool  check_name           ( const char *name );
  void  communicate          ( CHAR_DATA *dMob, char *txt, int range );
! void  load_muddata         ( void );
  CHAR_DATA  *check_reconnect( const char *player );
  
  // iterate across all the elements in a list
diff -crN nakedmudv1.5/src/world.c nakedmudv2.0/src/world.c
*** nakedmudv1.5/src/world.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/world.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 24,32 ****
  #include "storage.h"
  #include "world.h"
  
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  // the number of rooms we would expect, in different sized worlds
--- 24,36 ----
  #include "storage.h"
  #include "world.h"
  
! 
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! 
  
  
  // the number of rooms we would expect, in different sized worlds
***************
*** 117,127 ****
    return worldRemoveVnum(world, zoneRemoveObj, vnum);
  };
  
- #ifdef MODULE_SCRIPTS
  SCRIPT_DATA *worldRemoveScriptVnum(WORLD_DATA *world, script_vnum vnum) {
    return worldRemoveVnum(world, zoneRemoveScript, vnum);
  };
- #endif
  
  DIALOG_DATA *worldRemoveDialogVnum(WORLD_DATA *world, dialog_vnum vnum) {
    return worldRemoveVnum(world, zoneRemoveDialog, vnum);
--- 121,129 ----
***************
*** 139,149 ****
    return (worldRemoveObjVnum(world, objGetVnum(obj)) != NULL);
  };
  
- #ifdef MODULE_SCRIPTS
  bool worldRemoveScript(WORLD_DATA *world, SCRIPT_DATA *script) {
    return (worldRemoveScriptVnum(world, scriptGetVnum(script)) != NULL);
  };
- #endif
  
  bool worldRemoveDialog(WORLD_DATA *world, DIALOG_DATA *dialog) {
    return (worldRemoveDialogVnum(world, dialogGetVnum(dialog)) != NULL);
--- 141,149 ----
***************
*** 329,339 ****
    return worldGet(world, zoneGetObj, vnum);
  };
  
- #ifdef MODULE_SCRIPTS
  SCRIPT_DATA  *worldGetScript(WORLD_DATA *world, script_vnum vnum) {
    return worldGet(world, zoneGetScript, vnum);
  };
- #endif
  
  DIALOG_DATA  *worldGetDialog(WORLD_DATA *world, dialog_vnum vnum) {
    return worldGet(world, zoneGetDialog, vnum);
--- 329,337 ----
***************
*** 395,405 ****
    worldPut(world, zoneAddObj, obj, objGetVnum(obj));
  };
  
- #ifdef MODULE_SCRIPTS
  void worldPutScript(WORLD_DATA *world, SCRIPT_DATA *script) {
    worldPut(world, zoneAddScript, script, scriptGetVnum(script));
  };
- #endif
  
  void worldPutDialog(WORLD_DATA *world, DIALOG_DATA *dialog) {
    worldPut(world, zoneAddDialog, dialog, dialogGetVnum(dialog));
--- 393,401 ----
diff -crN nakedmudv1.5/src/world.d nakedmudv2.0/src/world.d
*** nakedmudv1.5/src/world.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/world.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ world.d world.o: world.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h zone.h room.h character.h \
+   object.h dialog.h utils.h storage.h world.h scripts/script.h
diff -crN nakedmudv1.5/src/wrapsock.h nakedmudv2.0/src/wrapsock.h
*** nakedmudv1.5/src/wrapsock.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/wrapsock.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 55,61 ****
--- 55,63 ----
  
  /* Defines */
  /* defined before the right type get a chance to be defined */
+ #ifndef socklen_t
  #define socklen_t unsigned int
+ #endif
  /* port to handle all requests */
  #define SERV_PORT1 9877 
  /* port to handle numeric requests */
diff -crN nakedmudv1.5/src/zone.c nakedmudv2.0/src/zone.c
*** nakedmudv1.5/src/zone.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/zone.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 18,32 ****
  #include "dialog.h"
  #include "zone.h"
  
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
- #endif
  
  
  struct zone_data {
!   char *name;
!   char *desc;
!   char *editors;
  
    WORLD_DATA     *world;
    PROPERTY_TABLE *rooms;
--- 18,34 ----
  #include "dialog.h"
  #include "zone.h"
  
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
  
  
  struct zone_data {
!   char   *name;
!   char   *editors;
!   BUFFER *desc;
  
    WORLD_DATA     *world;
    PROPERTY_TABLE *rooms;
***************
*** 49,55 ****
  ZONE_DATA *newZone(zone_vnum vnum, room_vnum min, room_vnum max) {
    ZONE_DATA *zone = malloc(sizeof(ZONE_DATA));
    zone->name    = strdup("");
!   zone->desc    = strdup("");
    zone->editors = strdup("");
    zone->vnum    = vnum;
    zone->min     = min;
--- 51,57 ----
  ZONE_DATA *newZone(zone_vnum vnum, room_vnum min, room_vnum max) {
    ZONE_DATA *zone = malloc(sizeof(ZONE_DATA));
    zone->name    = strdup("");
!   zone->desc    = newBuffer(1);
    zone->editors = strdup("");
    zone->vnum    = vnum;
    zone->min     = min;
***************
*** 61,69 ****
    zone->world = NULL;
    // maximum of about 5 rooms/bucket
    zone->rooms      = newPropertyTable(roomGetVnum,   1 + (max-min)/5);
- #ifdef MODULE_SCRIPTS
    zone->scripts    = newPropertyTable(scriptGetVnum, 1 + (max-min)/5);  
- #endif
    zone->dialogs    = newPropertyTable(dialogGetVnum, 1 + (max-min)/5);
    zone->mob_protos = newPropertyTable(charGetVnum,    1 + (max-min)/5);
    zone->obj_protos = newPropertyTable(objGetVnum,    1 + (max-min)/5);
--- 63,69 ----
***************
*** 81,87 ****
  
  void zoneCopyTo(ZONE_DATA *from, ZONE_DATA *to) {
    zoneSetName(to, zoneGetName(from));
!   zoneSetDescription(to, zoneGetDesc(from));
    zoneSetEditors(to, zoneGetEditors(from));
    to->vnum = from->vnum;
    to->min  = from->min;
--- 81,87 ----
  
  void zoneCopyTo(ZONE_DATA *from, ZONE_DATA *to) {
    zoneSetName(to, zoneGetName(from));
!   zoneSetDesc(to, zoneGetDesc(from));
    zoneSetEditors(to, zoneGetEditors(from));
    to->vnum = from->vnum;
    to->min  = from->min;
***************
*** 93,99 ****
  
  void deleteZone(ZONE_DATA *zone){ 
    if(zone->name)    free(zone->name);
!   if(zone->desc)    free(zone->desc);
    if(zone->editors) free(zone->editors);
  
    deletePropertyTable(zone->rooms);
--- 93,99 ----
  
  void deleteZone(ZONE_DATA *zone){ 
    if(zone->name)    free(zone->name);
!   if(zone->desc)    deleteBuffer(zone->desc);
    if(zone->editors) free(zone->editors);
  
    deletePropertyTable(zone->rooms);
***************
*** 165,171 ****
    zone->max         = read_int(set, "max");
    zone->pulse_timer = read_int(set, "pulse_timer");
    zoneSetName(zone,   read_string(set, "name"));
!   zoneSetDescription(zone,   read_string(set, "desc"));
    zoneSetEditors(zone,read_string(set, "editors"));
  
    deleteAuxiliaryData(zone->auxiliary_data);
--- 165,171 ----
    zone->max         = read_int(set, "max");
    zone->pulse_timer = read_int(set, "pulse_timer");
    zoneSetName(zone,   read_string(set, "name"));
!   zoneSetDesc(zone,   read_string(set, "desc"));
    zoneSetEditors(zone,read_string(set, "editors"));
  
    deleteAuxiliaryData(zone->auxiliary_data);
***************
*** 195,206 ****
    zoneReadData(zone, set, zoneAddDialog, dialogRead);
    storage_close(set);
  
- #ifdef MODULE_SCRIPTS
    sprintf(fname, "%s/scripts", dirpath);
    set = storage_read(fname);
    zoneReadData(zone, set, zoneAddScript, scriptRead);
    storage_close(set);
- #endif
    return zone;
  }
  
--- 195,204 ----
***************
*** 244,250 ****
    store_int   (set, "max",         zone->max);
    store_int   (set, "pulse_timer", zone->pulse_timer);
    store_string(set, "name",        zone->name);
!   store_string(set, "desc",        zone->desc);
    store_string(set, "editors",     zone->editors);
    store_set   (set, "auxiliary",   auxiliaryDataStore(zone->auxiliary_data));
    storage_write(set, fname);
--- 242,248 ----
    store_int   (set, "max",         zone->max);
    store_int   (set, "pulse_timer", zone->pulse_timer);
    store_string(set, "name",        zone->name);
!   store_string(set, "desc",        bufferString(zone->desc));
    store_string(set, "editors",     zone->editors);
    store_set   (set, "auxiliary",   auxiliaryDataStore(zone->auxiliary_data));
    storage_write(set, fname);
***************
*** 266,276 ****
    sprintf(fname, "%s/dialogs", dirpath);
    storage_write(set, fname);
  
- #ifdef MODULE_SCRIPTS
    set = zoneStoreData(zone, zoneGetScript, scriptStore);
    sprintf(fname, "%s/scripts", dirpath);
    storage_write(set, fname);
- #endif
  
    return TRUE;
  }
--- 264,272 ----
***************
*** 314,324 ****
    zoneAdd(zone, zone->obj_protos, "object", obj, objGetVnum(obj));
  }
  
- #ifdef MODULE_SCRIPTS
  void zoneAddScript(ZONE_DATA *zone, SCRIPT_DATA *script) {
    zoneAdd(zone, zone->scripts, "script", script, scriptGetVnum(script));
  }
- #endif
  
  void zoneAddDialog(ZONE_DATA *zone, DIALOG_DATA *dialog) {
    zoneAdd(zone, zone->dialogs, "dialog", dialog, dialogGetVnum(dialog));
--- 310,318 ----
***************
*** 351,361 ****
    return zoneRemove(zone, zone->obj_protos, "obj", obj);
  }
  
- #ifdef MODULE_SCRIPTS
  SCRIPT_DATA *zoneRemoveScript(ZONE_DATA *zone, script_vnum script) { 
    return zoneRemove(zone, zone->scripts, "script", script);
  }
- #endif
  
  DIALOG_DATA *zoneRemoveDialog(ZONE_DATA *zone, dialog_vnum dialog) { 
    return zoneRemove(zone, zone->dialogs, "dialog", dialog);
--- 345,353 ----
***************
*** 415,429 ****
  }
  
  const char *zoneGetDesc(ZONE_DATA *zone) { 
!   return zone->desc;
  }
  
  const char *zoneGetEditors(ZONE_DATA *zone) {
    return zone->editors;
  }
  
! char **zoneGetDescPtr(ZONE_DATA *zone) {
!   return &(zone->desc);
  }
  
  //
--- 407,421 ----
  }
  
  const char *zoneGetDesc(ZONE_DATA *zone) { 
!   return bufferString(zone->desc);
  }
  
  const char *zoneGetEditors(ZONE_DATA *zone) {
    return zone->editors;
  }
  
! BUFFER *zoneGetDescBuffer(ZONE_DATA *zone) {
!   return zone->desc;
  }
  
  //
***************
*** 453,463 ****
    return zoneGet(zone, zone->obj_protos, "obj", obj);
  }
  
- #ifdef MODULE_SCRIPTS
  SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, script_vnum script) {
    return zoneGet(zone, zone->scripts, "script", script);
  };
- #endif
  
  DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, dialog_vnum dialog) {
    return zoneGet(zone, zone->dialogs, "dialog", dialog);
--- 445,453 ----
***************
*** 495,503 ****
    zone->name = (name ? strdup(name) : strdup("\0"));
  }
  
! void zoneSetDescription(ZONE_DATA *zone, const char *description) { 
!   if(zone->desc) free(zone->desc);
!   zone->desc = (description ? strdup(description) : strdup("\0"));
  }
  
  void zoneSetEditors(ZONE_DATA *zone, const char *names) {
--- 485,493 ----
    zone->name = (name ? strdup(name) : strdup("\0"));
  }
  
! void zoneSetDesc(ZONE_DATA *zone, const char *desc) { 
!   bufferClear(zone->desc);
!   bufferCat(zone->desc, desc);
  }
  
  void zoneSetEditors(ZONE_DATA *zone, const char *names) {
diff -crN nakedmudv1.5/src/zone.d nakedmudv2.0/src/zone.d
*** nakedmudv1.5/src/zone.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/zone.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ zone.d zone.o: zone.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h storage.h object.h character.h room.h \
+   utils.h auxiliary.h dialog.h zone.h scripts/script.h
diff -crN nakedmudv1.5/src/zone.h nakedmudv2.0/src/zone.h
*** nakedmudv1.5/src/zone.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/zone.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 92,104 ****
  const char *zoneGetName(ZONE_DATA *zone);
  const char *zoneGetDesc(ZONE_DATA *zone);
  const char *zoneGetEditors(ZONE_DATA *zone);
! char      **zoneGetDescPtr(ZONE_DATA *zone);
  bool        canEditZone(ZONE_DATA *zone, CHAR_DATA *ch);
  ROOM_DATA  *zoneGetRoom(ZONE_DATA *zone, room_vnum room);
  CHAR_DATA   *zoneGetMob(ZONE_DATA *zone, mob_vnum room);
  OBJ_DATA   *zoneGetObj(ZONE_DATA *zone, obj_vnum obj);
  SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, script_vnum script);
! DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, dialog_vnum script);
  void        *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name);
  
  void zoneSetVnum(ZONE_DATA *zone, zone_vnum vnum);
--- 92,104 ----
  const char *zoneGetName(ZONE_DATA *zone);
  const char *zoneGetDesc(ZONE_DATA *zone);
  const char *zoneGetEditors(ZONE_DATA *zone);
! BUFFER     *zoneGetDescBuffer(ZONE_DATA *zone);
  bool        canEditZone(ZONE_DATA *zone, CHAR_DATA *ch);
  ROOM_DATA  *zoneGetRoom(ZONE_DATA *zone, room_vnum room);
  CHAR_DATA   *zoneGetMob(ZONE_DATA *zone, mob_vnum room);
  OBJ_DATA   *zoneGetObj(ZONE_DATA *zone, obj_vnum obj);
  SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, script_vnum script);
! DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, dialog_vnum dialog);
  void        *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name);
  
  void zoneSetVnum(ZONE_DATA *zone, zone_vnum vnum);
***************
*** 108,114 ****
  void zoneSetPulse(ZONE_DATA *zone, int pulse_left);
  void zoneSetWorld(ZONE_DATA *zone, WORLD_DATA *world);
  void zoneSetName(ZONE_DATA *zone, const char *name);
! void zoneSetDescription(ZONE_DATA *zone, const char *description);
  void zoneSetEditors(ZONE_DATA *zone, const char *names);
  //*****************************************************************************
  //
--- 108,114 ----
  void zoneSetPulse(ZONE_DATA *zone, int pulse_left);
  void zoneSetWorld(ZONE_DATA *zone, WORLD_DATA *world);
  void zoneSetName(ZONE_DATA *zone, const char *name);
! void zoneSetDesc(ZONE_DATA *zone, const char *description);
  void zoneSetEditors(ZONE_DATA *zone, const char *names);
  //*****************************************************************************
  //
